#include <windows.h>
#include <zmouse.h>
#include <tchar.h>
#include <stdio.h>
#include <string.h>
#define KMELEON_PLUGIN_EXPORTS
#include <kmeleon_plugin.h>

#define PLUGIN_NAME "Logitec mouse wheel plugin"

long DoMessage(const char *to, const char *from, const char *subject,
               long data1, long data2);
void Create(HWND);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

WNDPROC KMeleonWndProc;

kmeleonPlugin kPlugin = {
	KMEL_PLUGIN_VER,
	PLUGIN_NAME,
	DoMessage
};


long DoMessage(const char *to, const char *from, const char *subject,
               long data1, long data2)
{
	if (to[0] == '*' || stricmp(to, kPlugin.dllname) == 0) {
		if (stricmp(subject, "Create") == 0) {
			Create((HWND)data1);
		}
		else return 0;
		return 1;
	}
	return 0;
}


void Create(HWND hWndParent)
{
	KMeleonWndProc = (WNDPROC) GetWindowLong(hWndParent, GWL_WNDPROC);
	SetWindowLong(hWndParent, GWL_WNDPROC, (LONG)WndProc);
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
	switch (message) {
	case WM_MOUSEWHEEL:
		{
			int delta = GET_WHEEL_DELTA_WPARAM(wParam);
			int i;
			BYTE vk;
			if (delta > 0) {
				vk = VK_UP;
			} else {
				vk = VK_DOWN;
				delta = - delta;
			}
			for (i = 0; i < delta; i ++) {
				keybd_event(vk, 0, 0, 0);
				keybd_event(vk, 0, 2, 0);
			}
		}
		return 0;
	}
	return CallWindowProc(KMeleonWndProc, hWnd, message, wParam, lParam);
}

extern "C" {
	KMELEON_PLUGIN kmeleonPlugin *GetKmeleonPlugin() {
		return &kPlugin;
	}
}
